/*------------------------------------------------------------------
MPSDData.cpp: Implementation of CPageData
------------------------------------------------------------------*/
#include "stdafx.h"
#include "MPSDData.h"

IMPLEMENT_SERIAL(CPageData, CObject, 1)

CPageData::CPageData() :m_lPageLength(0), m_strPageFile("") 
{
    m_iPageType =PDTYPE_TEXT;
}

CPageData::~CPageData()
{
    if (!m_strPageFile.IsEmpty()) {
        DeleteFile(m_strPageFile);
        m_strPageFile.Empty();
    }
}

void CPageData::Serialize(CArchive& ar) 
{
    CString str; LPTSTR p;

    if (ar.IsStoring()) 
    {    
        if (m_strPageFile.IsEmpty()) {
            ASSERT(m_lPageLength==0);
            ar << m_lPageLength;
            return;
        }

        CFile f(m_strPageFile, CFile::modeRead);
        m_lPageLength = f.GetLength();

        ar << m_lPageLength;
        ar << m_iPageType;

        p = str.GetBuffer(m_lPageLength);
        f.Read(p, m_lPageLength);
        f.Close();

        ar.Write(p, m_lPageLength);
        str.ReleaseBuffer( );
    }
    else          // loading 
    {     
        ar >> m_lPageLength;
        if (m_lPageLength==0) return;

        ar >> m_iPageType;

        p = str.GetBuffer(m_lPageLength);
        ar.Read(p, m_lPageLength);

        m_strPageFile = GetTempFile(); // with modeCreate
        CFile f(m_strPageFile, CFile::modeWrite);
        f.Write(p, m_lPageLength);

        f.Close();
        str.ReleaseBuffer( );
    }
}

CString GetTempFile()
{
    TCHAR szTemp[_MAX_PATH];
    if (!GetTempPath(_MAX_PATH, szTemp)) return "";
    if (!GetTempFileName(szTemp, "zd_", 0, szTemp)) return "";
    return szTemp;
}

