/*------------------------------------------------------------------
MPSDDoc.h: Interface of the CMPSDDoc class
Author:    Zuoliu Ding
------------------------------------------------------------------*/
#if !defined(__MPSDData_H__)
#define __MPSDData_H__

#include "MPSDData.h"

class AFX_EXT_CLASS CMPSDDoc : public CDocument
{
protected: // create from serialization only
    CMPSDDoc();
    DECLARE_DYNCREATE(CMPSDDoc)

public:
    void    PageAdd();
    BOOL    PageImport(CString strFile);
    void    PageNotify(long lCurPage);
    void    PageDelete();

    void    UpdateCurPage(CPageData* pPageData);
    void    SaveCurPage();

    long    GetTotalNumber() {return m_lTotalPages;}
    long    GetCurPageIndex() {return m_lCurPage;}
    void    SetCurPageModiFlag(BOOL b=TRUE) {m_bCurModified =b;}
    void    SetInsertPageFlag(BOOL b=TRUE) {m_bInsertPage =b;}

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CMPSDDoc)
    public:
    virtual BOOL OnNewDocument();
    virtual void Serialize(CArchive& ar);
    virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
    //}}AFX_VIRTUAL

    virtual ~CMPSDDoc();

private:
    long        m_lTotalPages;
    long        m_lCurPage;
    BOOL        m_bCurModified;
    BOOL        m_bInsertPage;

    CObArray    m_aryPageData;        
};

#endif 


