VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsWDJPopup"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event PopupMenuSelected(iMenuItemSelected As Integer)

Public Function showArray(asMenuItems() As String) As Integer

    Dim iNdx As Integer
    Dim iPos As Integer
    
    Dim lErr As Long
    Dim hWnd As Long
    Dim hMenu As Long
    Dim lMenuOpt As Long
    
    Dim pt As POINTAPI
    Dim message As Msg
    Dim nullRect As RECT
    
'/* default (ie. if user escapes) */
    m_iPopupMenu = -1
    
'/* where is the mouse? */
    Call GetCursorPos(pt)
    
'/* define windows class and register */
    Dim wndcls As WNDCLASS
    wndcls.style = CS_HREDRAW + CS_VREDRAW
    wndcls.lpfnwndproc = AddressOf2Long(AddressOf popupMenuWndProc)
    wndcls.cbClsextra = 0
    wndcls.cbWndExtra2 = 0
    wndcls.hInstance = App.hInstance
    wndcls.hIcon = 0
    wndcls.hCursor = 0
    wndcls.hbrBackground = COLOR_WINDOW
    wndcls.lpszMenuName = 0
    wndcls.lpszClassName = "popupMenu"

    lErr = RegisterClass(wndcls)

    If lErr <> 0 Then
    
    '/* create window cause we need the handle */
        hWnd = CreateWindowEx(0, "popupMenu", "", _
                              WS_OVERLAPPEDWINDOW, 0, 0, 1, 1, 0, _
                              0, App.hInstance, ByVal 0&)
        If hWnd <> 0 Then
        
        '/* build popup menu from string array parameter */
            hMenu = CreatePopupMenu()
            
            For iNdx = 1 To UBound(asMenuItems)
          
            '/* use dash as menu separator */
                If asMenuItems(iNdx) = "-" Then
                    Call AppendMenu(hMenu, MF_SEPARATOR, _
                                    100 + iNdx, "")
                  
                Else
                
                '/* use null as disabled indicator */
                    If Left$(asMenuItems(iNdx), 1) = Chr$(0) Then
                        lMenuOpt = MF_GRAYED
                        iPos = 2
                    Else
                        lMenuOpt = MF_ENABLED
                        iPos = 1
                    End If
                    
                    Call AppendMenu(hMenu, lMenuOpt, 100 + iNdx, _
                                    Mid$(asMenuItems(iNdx), iPos))
                End If
              
            Next iNdx
    
        '/* put menu at current cursor position */
            Call ClientToScreen(hWnd, pt)
            lErr = TrackPopupMenu(hMenu, TPM_LEFTALIGN, pt.X, _
                                  pt.Y, 0, hWnd, nullRect)
            
        '/* GetMessage only returns when window message is */
        '/* WM_QUIT we want to return when no messages are in */
        '/* the message queue ie. when a menu item is selected */
            Do While PeekMessage(message, hWnd, 0, 0, PM_REMOVE)
                Call TranslateMessage(message)
                Call DispatchMessage(message)
            Loop

        End If
      
    '/* clean up */
        lErr = DestroyWindow(hWnd)
'Debug.Print "destroywindow="; lErr

        lErr = DestroyMenu(hMenu)
'Debug.Print "destroymenu="; lErr

        lErr = UnregisterClass("popupMenu", App.hInstance)
'Debug.Print "unregister="; lErr
      
    End If
    
'/* raise selected event */
    RaiseEvent PopupMenuSelected(m_iPopupMenu)
    
'/* return */
    showArray = m_iPopupMenu
    
End Function


Public Function show(ParamArray vMenuItems() As Variant) As Integer

    Dim iNdx As Integer
    
    Dim asMenuItems() As String
    
'/* convert variant array to string array */
    ReDim asMenuItems(UBound(vMenuItems) + 1)
    
    For iNdx = 0 To UBound(vMenuItems)
      asMenuItems(iNdx + 1) = vMenuItems(iNdx)
    Next iNdx
    
    Call showArray(asMenuItems)
    
'/* return */
    show = m_iPopupMenu
    
End Function

